if (!defined &_SYS_DKTP_DPT_H) {
    eval 'sub _SYS_DKTP_DPT_H {1;}';
    if (defined &__cplusplus) {
    }
    eval 'sub DPT_KVTOP {
        local($vaddr) = @_;
        eval "( &HBA_KVTOP(($vaddr),  &dpt_pgshf,  &dpt_pgmsk))";
    }';
    eval 'sub DPT_PHYMAX_DMASEGS {64;}';
    eval 'sub DPT_MAX_DMA_SEGS {32;}';
    eval 'sub DPT_SENSE_LEN {0x18;}';
    eval 'sub DPT_OK {0x0;}';
    eval 'sub DPT_SELTO {0x1;}';
    eval 'sub DPT_CMDTO {0x2;}';
    eval 'sub DPT_BUSRST {0x3;}';
    eval 'sub DPT_POWUP {0x4;}';
    eval 'sub DPT_PHASERR {0x5;}';
    eval 'sub DPT_BUSFREE {0x6;}';
    eval 'sub DPT_BUSPARITY {0x7;}';
    eval 'sub DPT_BUSHUNG {0x8;}';
    eval 'sub DPT_MSGREJECT {0x9;}';
    eval 'sub DPT_RSTSTUCK {0x0a;}';
    eval 'sub DPT_REQSENFAIL {0x0b;}';
    eval 'sub DPT_HAPARITY {0x0c;}';
    eval 'sub DPT_CPABORTNOTACTIVE {0x0d;}';
    eval 'sub DPT_CPBUSABORT {0x0e;}';
    eval 'sub DPT_CPRESETNOTACTIVE {0x0f;}';
    eval 'sub DPT_CPRESETONBUS {0x10;}';
    eval 'sub DPT_CSRAMECC {0x11;}';
    eval 'sub DPT_CSPCIPE {0x12;}';
    eval 'sub DPT_CSPCIRMA {0x13;}';
    eval 'sub DPT_CSPCIRTA {0x14;}';
    eval 'sub DPT_CSPCISTA {0x15;}';
    if (defined &DPT_DEBUG) {
	eval 'sub DPT_UNKNOWN_ERROR {0x16;}';
    }
    if (defined &DPT_DEBUG) {
    }
    eval 'sub ccb_optbit { &ccb_option. &b_bit;}';
    eval 'sub ccb_optbyte { &ccb_option. &b_byte;}';
    eval 'sub ccb_scratch { &cc. &b_scratch;}';
    eval 'sub ccb_ownerp { &cc. &b_ownerp;}';
    if (defined &DPT_DEBUG) {
    }
    eval 'sub DPT_DIP {
        local($dpt) = @_;
        eval "((($dpt)-> &d_blkp)-> &db_dip)";
    }';
    eval 'sub TRAN2HBA {
        local($hba) = @_;
        eval "(($hba)-> &tran_hba_private)";
    }';
    eval 'sub SDEV2HBA {
        local($sd) = @_;
        eval "( &TRAN2HBA( &SDEV2TRAN($sd)))";
    }';
    eval 'sub TRAN2DPT {
        local($hba) = @_;
        eval "(($hba)-> &tran_tgt_private)";
    }';
    eval 'sub TRAN2DPTBLKP {
        local($hba) = @_;
        eval "(( &TRAN2DPT($hba))-> &d_blkp)";
    }';
    eval 'sub TRAN2DPTUNITP {
        local($hba) = @_;
        eval "(( &TRAN2DPT($hba))-> &d_unitp)";
    }';
    eval 'sub SDEV2DPT {
        local($sd) = @_;
        eval "( &TRAN2DPT( &SDEV2TRAN($sd)))";
    }';
    eval 'sub PKT2DPT {
        local($pktp) = @_;
        eval "( &TRAN2DPT( &PKT2TRAN($pktp)))";
    }';
    eval 'sub PKT2DPTUNITP {
        local($pktp) = @_;
        eval "( &TRAN2DPTUNITP( &PKT2TRAN($pktp)))";
    }';
    eval 'sub PKT2DPTBLKP {
        local($pktp) = @_;
        eval "( &TRAN2DPTBLKP( &PKT2TRAN($pktp)))";
    }';
    eval 'sub ADDR2DPTUNITP {
        local($ap) = @_;
        eval "( &TRAN2DPTUNITP( &ADDR2TRAN($ap)))";
    }';
    eval 'sub ADDR2DPTBLKP {
        local($ap) = @_;
        eval "( &TRAN2DPTBLKP( &ADDR2TRAN($ap)))";
    }';
    eval 'sub DPT_BLKP {
        local($X) = @_;
        eval "((($X))-> &d_blkp)";
    }';
    eval 'sub DPT_MAX_CTRLS {18;}';
    eval 'sub HBA_BUS_TYPE_LENGTH {32;}';
    eval 'sub HA_COMMAND {0x07;}';
    eval 'sub HA_STATUS {0x07;}';
    eval 'sub HA_DMA_BASE {0x02;}';
    eval 'sub HA_ERROR {0x01;}';
    eval 'sub HA_DATA {0x00;}';
    eval 'sub HA_AUX_STATUS {0x08;}';
    eval 'sub HA_IMMED_MOD {0x05;}';
    eval 'sub HA_IMMED_FUNC {0x06;}';
    eval 'sub HA_GEN_CODE {0x06;}';
    eval 'sub HA_GEN_ABORT_TARGET {0x05;}';
    eval 'sub HA_GEN_ABORT_LUN {0x04;}';
    eval 'sub HA_AUX_BUSY {0x01;}';
    eval 'sub HA_AUX_INTR {0x02;}';
    eval 'sub HA_ST_ERROR {0x01;}';
    eval 'sub HA_ST_INDEX {0x02;}';
    eval 'sub HA_ST_CORRCTD {0x04;}';
    eval 'sub HA_ST_DRQ {0x08;}';
    eval 'sub HA_ST_SEEK_COMP {0x10;}';
    eval 'sub HA_ST_WRT_FLT {0x20;}';
    eval 'sub HA_ST_READY {0x40;}';
    eval 'sub HA_ST_BUSY {0x80;}';
    eval 'sub HA_ST_DATA_RDY { &HA_ST_SEEK_COMP +  &HA_ST_READY +  &HA_ST_DRQ;}';
    eval 'sub HA_SELTO {0x01;}';
    eval 'sub CP_READ_CFG_PIO {0xF0;}';
    eval 'sub CP_PIO_CMD {0xF2;}';
    eval 'sub CP_TRUCATE_CMD {0xF4;}';
    eval 'sub CP_READ_CFG_DMA {0xFD;}';
    eval 'sub CP_SET_CFG_DMA {0xFE;}';
    eval 'sub CP_EATA_RESET {0xF9;}';
    eval 'sub CP_DMA_CMD {0xFF;}';
    eval 'sub ECS_EMULATE_SEN {0xD4;}';
    eval 'sub CP_EATA_IMMED {0xFA;}';
    eval 'sub CP_EI_ABORT_MSG {0x00;}';
    eval 'sub CP_EI_RESET_MSG {0x01;}';
    eval 'sub CP_EI_RESET_BUS {0x02;}';
    eval 'sub CP_EI_ABORT_CP {0x03;}';
    eval 'sub CP_EI_INTERRUPTS {0x04;}';
    eval 'sub CP_EI_MOD_ENABLE {0x00;}';
    eval 'sub CP_EI_MOD_DISABLE {0x01;}';
    eval 'sub HA_DATA_IN {0x80;}';
    eval 'sub HA_DATA_OUT {0x40;}';
    eval 'sub HA_CP_QUICK {0x10;}';
    eval 'sub HA_SCATTER {0x08;}';
    eval 'sub HA_AUTO_REQSEN {0x04;}';
    eval 'sub HA_HBA_INIT {0x02;}';
    eval 'sub HA_SCSI_RESET {0x01;}';
    eval 'sub HA_STATUS_MASK {0x7F;}';
    eval 'sub HA_IDENTIFY_MSG {0x80;}';
    eval 'sub HA_DISCO_RICO {0x40;}';
    eval 'sub FLUSH_CACHE_CMD {0x35;}';
    eval 'sub SCBP {
        local($pkt) = @_;
        eval "(($pkt)-> &pkt_scbp)";
    }';
    eval 'sub SCBP_C {
        local($pkt) = @_;
        eval "((*($pkt)-> &pkt_scbp) &  &STATUS_MASK)";
    }';
    eval 'sub PCI_DPT_VEND_ID {0x1044;}';
    eval 'sub PCI_DPT_DEV_ID {0xa400;}';
    eval 'sub MAX_PCI_BUS {1;}';
    eval 'sub MAX_PCI_DEVICE {32;}';
    eval 'sub DPT_PCI_ADAPTER {0;}';
    eval 'sub DPT_EISA_ADAPTER {1;}';
    eval 'sub DPT_ISA_ADAPTER {2;}';
    if (defined &__cplusplus) {
    }
}
1;
