if (!defined &_SYS_PTE_H) {
    eval 'sub _SYS_PTE_H {1;}';
    if (!defined &_ASM) {
	require 'sys/types.ph';
    }
    if (defined &__cplusplus) {
    }
    if (!defined &_ASM) {
	eval 'sub MRPTEOF {
	    local($ppn, $os, $m, $r, $c, $w, $a, $p) = @_;
	    eval "((($ppn)<<12)|(($os)<<9)|(($m)<<6)|(($r)<<5)| ((!($c))<<4)|(($w)<<3)|(($a)<<1)|$p)";
	}';
	eval 'sub PTEOF {
	    local($p, $a, $c) = @_;
	    eval " &MRPTEOF($p, 0, 0, 0, $c, 0, $a, 1)";
	}';
    }
    eval 'sub PTE_RM_MASK {0x60;}';
    eval 'sub PTE_REF_MASK {0x20;}';
    eval 'sub PTE_MOD_MASK {0x40;}';
    eval 'sub PTE_RM_SHIFT {5;}';
    eval 'sub PTE_PERMS {
        local($b) = @_;
        eval "((($b) & 0x3) << 1)";
    }';
    eval 'sub PTE_PERMMASK {((0x3 << 1));}';
    eval 'sub PTE_PERMSHIFT {(1);}';
    eval 'sub PTE_WRITETHRU {
        local($w) = @_;
        eval "((($w) & 0x1) << 3)";
    }';
    eval 'sub PTE_NONCACHEABLE {
        local($d) = @_;
        eval "((($d) & 0x1) << 4)";
    }';
    eval 'sub PTE_REF {
        local($r) = @_;
        eval "((($r) & 0x1) << 5)";
    }';
    eval 'sub PTE_MOD {
        local($m) = @_;
        eval "((($m) & 0x1) << 6)";
    }';
    eval 'sub PTE_OSRESERVED {
        local($o) = @_;
        eval "((($o) & 0x7) << 9)";
    }';
    eval 'sub PTE_PFN {
        local($p) = @_;
        eval "((($p)) >> 12)";
    }';
    eval 'sub pte_valid {
        local($pte) = @_;
        eval "(($pte)-> &Present)";
    }';
    eval 'sub pte_konly {
        local($pte) = @_;
        eval "(((*($pte)) & 0x4) == 0)";
    }';
    eval 'sub pte_ronly {
        local($pte) = @_;
        eval "(((*($pte)) & 0x2) == 0)";
    }';
    eval 'sub pte_cacheable {
        local($pte) = @_;
        eval "(((*($pte)) & 0x10) == 0)";
    }';
    eval 'sub pte_writethru {
        local($pte) = @_;
        eval "(((*($pte)) & 0x8) == 0)";
    }';
    eval 'sub pte_accessed {
        local($pte) = @_;
        eval "((*($pte)) & 0x20)";
    }';
    eval 'sub pte_dirty {
        local($pte) = @_;
        eval "((*($pte)) & 0x40)";
    }';
    eval 'sub pte_accdir {
        local($pte) = @_;
        eval "((*($pte)) & 0x60)";
    }';
    eval 'sub MAKE_PFNUM {
        local($a) = @_;
        eval "((($a))-> &PhysicalPageNumber)";
    }';
    eval 'sub PG_V {1;}';
    eval 'sub MMU_STD_SRX {0;}';
    eval 'sub MMU_STD_SRWX {1;}';
    eval 'sub MMU_STD_SRXURX {2;}';
    eval 'sub MMU_STD_SRWXURWX {3;}';
    eval 'sub MAKE_PROT {
        local($v) = @_;
        eval " &PTE_PERMS($v)";
    }';
    eval 'sub PG_PROT { &MAKE_PROT(0x3);}';
    eval 'sub PG_KW { &MAKE_PROT( &MMU_STD_SRWX);}';
    eval 'sub PG_KR { &MAKE_PROT( &MMU_STD_SRX);}';
    eval 'sub PG_UW { &MAKE_PROT( &MMU_STD_SRWXURWX);}';
    eval 'sub PG_URKR { &MAKE_PROT( &MMU_STD_SRXURX);}';
    eval 'sub PG_UR { &MAKE_PROT( &MMU_STD_SRXURX);}';
    eval 'sub PG_UPAGE { &PG_KW;}';
    eval 'sub MMU_STD_PAGEMASK {0xFFFFF000;}';
    eval 'sub MMU_STD_PAGESHIFT {12;}';
    eval 'sub MMU_STD_PAGESIZE {(1 <<  &MMU_STD_PAGESHIFT);}';
    eval 'sub MMU_STD_SEGSHIFT {22;}';
    eval 'sub MMU_L1_INDEX {
        local($a) = @_;
        eval "((($a)) >> 22)";
    }';
    eval 'sub MMU_L2_INDEX {
        local($a) = @_;
        eval "((($a) >> 12) & 0x3ff)";
    }';
    eval 'sub MMU_L1_VA {
        local($a) = @_;
        eval "(($a) << 22)";
    }';
    eval 'sub MMU_L2_VA {
        local($a) = @_;
        eval "(($a) << 12)";
    }';
    eval 'sub four_mb_page {
        local($pte) = @_;
        eval "(*(($pte)) & 0x80)";
    }';
    eval 'sub IN_SAME_4MB_PAGE {
        local($a, $b) = @_;
        eval "( &MMU_L1_INDEX($a) ==  &MMU_L1_INDEX($b))";
    }';
    eval 'sub FOURMB_PDE {
        local($a, $g,  $b, $c) = @_;
        eval "((($a) << 12) | (($g) << 8) | 0x80 |((($b) & 0x03) << 1) | ($c))";
    }';
    if (!defined &_ASM) {
    }
    eval 'sub MMU_STD_INVALIDPTE {(0);}';
    eval 'sub MMU_NPTE_ONE {1024;}';
    eval 'sub MMU_NPTE_TWO {1024;}';
    if (!defined( &_ASM) && defined( &_KERNEL)) {
	eval 'sub pte_memory {
	    local($pte) = @_;
	    eval "( &pf_is_memory(($pte)-> &PhysicalPageNumber))";
	}';
    }
    if (defined &__cplusplus) {
    }
}
1;
