if (!defined &_KERBEROS_KRB_H) {
    eval 'sub _KERBEROS_KRB_H {1;}';
    require 'kerberos/mit-copyright.ph';
    require 'kerberos/des.ph';
    if (defined &__cplusplus) {
    }
    eval 'sub KRB_ERRORS_TABLE_SIZE {256;}';
    eval 'sub MAX_KRB_ERRORS {( &KRB_ERRORS_TABLE_SIZE-1);}';
    if (defined( &ULTRIX022) || (defined( &SunOS) &&  &SunOS < 40)) {
	eval 'sub FD_ZERO {
	    local($p) = @_;
	    eval "(($p)-> &fds_bits[0] = 0)";
	}';
	eval 'sub FD_SET {
	    local($n, $p) = @_;
	    eval "(($p)-> &fds_bits[0] |= (1 << ($n)))";
	}';
	eval 'sub FD_ISSET {
	    local($n, $p) = @_;
	    eval "(($p)-> &fds_bits[0] & (1 << ($n)))";
	}';
    }
    eval 'sub KSUCCESS {0;}';
    eval 'sub KFAILURE {255;}';
    if (defined &NO_UIDGID_T) {
    }
    if (defined &notdef) {
	eval 'sub KRBLOG {"/kerberos/kerberos.log";}';
	eval 'sub VX_KRB_HSTFILE {"/etc/krbhst";}';
	eval 'sub PC_KRB_HSTFILE {"\\\\kerberos\\\\krbhst";}';
    }
    eval 'sub KRB_CONF {"/etc/krb.conf";}';
    eval 'sub KRB_RLM_TRANS {"/etc/krb.realms";}';
    eval 'sub KRB_MASTER {"kerberos";}';
    eval 'sub KRB_HOST { &KRB_MASTER;}';
    eval 'sub KRB_REALM { &krb_get_default_realm();}';
    if (defined &NIS) {
	eval 'sub KRB_CONF_MAP {"krb.conf";}';
	eval 'sub KRB_REALM_DEFKEY {"DEFAULT_REALM";}';
    }
    eval 'sub ANAME_SZ {40;}';
    eval 'sub REALM_SZ {40;}';
    eval 'sub SNAME_SZ {40;}';
    eval 'sub INST_SZ {40;}';
    eval 'sub MAX_K_NAME_SZ {( &ANAME_SZ +  &INST_SZ +  &REALM_SZ + 2);}';
    eval 'sub KKEY_SZ {100;}';
    eval 'sub VERSION_SZ {1;}';
    eval 'sub MSG_TYPE_SZ {1;}';
    eval 'sub DATE_SZ {26;}';
    eval 'sub MAX_HSTNM {100;}';
    if (!defined &DEFAULT_TKT_LIFE) {
	eval 'sub DEFAULT_TKT_LIFE {96;}';
    }
    eval 'sub MAX_KTXT_LEN {1250;}';
    eval 'sub CLIENT_KRB_TIMEOUT {4;}';
    eval 'sub CLIENT_KRB_RETRY {5;}';
    eval 'sub CLIENT_KRB_BUFLEN {512;}';
    eval 'sub R_TKT_FIL {0;}';
    eval 'sub W_TKT_FIL {1;}';
    if (defined &PC) {
	eval 'sub CL_GTGT_INIT_FILE {"\\\\kerberos\\\\k_in_tkts";}';
    }
    else {
	eval 'sub CL_GTGT_INIT_FILE {"/etc/k_in_tkts";}';
    }
    eval 'sub CLOCK_SKEW {5*60;}';
    eval 'sub KEYFILE {"/etc/srvtab";}';
    if (defined &PC) {
	eval 'sub TKT_FILE {"\\\\kerberos\\\\ticket.ses";}';
    }
    else {
	eval 'sub TKT_FILE { &tkt_string();}';
	eval 'sub TKT_ROOT {"/tmp/tkt";}';
    }
    eval 'sub KDC_OK {0;}';
    eval 'sub KDC_NAME_EXP {1;}';
    eval 'sub KDC_SERVICE_EXP {2;}';
    eval 'sub KDC_AUTH_EXP {3;}';
    eval 'sub KDC_PKT_VER {4;}';
    eval 'sub KDC_P_MKEY_VER {5;}';
    eval 'sub KDC_S_MKEY_VER {6;}';
    eval 'sub KDC_BYTE_ORDER {7;}';
    eval 'sub KDC_PR_UNKNOWN {8;}';
    eval 'sub KDC_PR_N_UNIQUE {9;}';
    eval 'sub KDC_NULL_KEY {10;}';
    eval 'sub KDC_GEN_ERR {20;}';
    eval 'sub GC_OK {0;}';
    eval 'sub RET_OK {0;}';
    eval 'sub GC_TKFIL {21;}';
    eval 'sub RET_TKFIL {21;}';
    eval 'sub GC_NOTKT {22;}';
    eval 'sub RET_NOTKT {22;}';
    eval 'sub MK_AP_OK {0;}';
    eval 'sub MK_AP_TGTEXP {26;}';
    eval 'sub RD_AP_OK {0;}';
    eval 'sub RD_AP_UNDEC {31;}';
    eval 'sub RD_AP_EXP {32;}';
    eval 'sub RD_AP_NYV {33;}';
    eval 'sub RD_AP_REPEAT {34;}';
    eval 'sub RD_AP_NOT_US {35;}';
    eval 'sub RD_AP_INCON {36;}';
    eval 'sub RD_AP_TIME {37;}';
    eval 'sub RD_AP_BADD {38;}';
    eval 'sub RD_AP_VERSION {39;}';
    eval 'sub RD_AP_MSG_TYPE {40;}';
    eval 'sub RD_AP_MODIFIED {41;}';
    eval 'sub RD_AP_ORDER {42;}';
    eval 'sub RD_AP_UNAUTHOR {43;}';
    eval 'sub GT_PW_OK {0;}';
    eval 'sub GT_PW_NULL {51;}';
    eval 'sub GT_PW_BADPW {52;}';
    eval 'sub GT_PW_PROT {53;}';
    eval 'sub GT_PW_KDCERR {54;}';
    eval 'sub GT_PW_NULLTKT {55;}';
    eval 'sub SKDC_OK {0;}';
    eval 'sub SKDC_RETRY {56;}';
    eval 'sub SKDC_CANT {57;}';
    eval 'sub INTK_OK {0;}';
    eval 'sub INTK_W_NOTALL {61;}';
    eval 'sub INTK_BADPW {62;}';
    eval 'sub INTK_PROT {63;}';
    eval 'sub INTK_ERR {70;}';
    eval 'sub AD_OK {0;}';
    eval 'sub AD_NOTGT {71;}';
    eval 'sub NO_TKT_FIL {76;}';
    eval 'sub TKT_FIL_ACC {77;}';
    eval 'sub TKT_FIL_LCK {78;}';
    eval 'sub TKT_FIL_FMT {79;}';
    eval 'sub TKT_FIL_INI {80;}';
    eval 'sub KNAME_FMT {81;}';
    eval 'sub SAFE_PRIV_ERROR {-1;}';
    eval 'sub swap_u_16 {
        local($x) = @_;
        eval "{ \'unsigned long\'  &_krb_swap_tmp[4];  &swab(($x) +0, ( &_krb_swap_tmp) +14, 2);  &swab(($x) +2, ( &_krb_swap_tmp) +12, 2);  &swab(($x) +4, ( &_krb_swap_tmp) +10, 2);  &swab(($x) +6, ( &_krb_swap_tmp) +8, 2);  &swab(($x) +8, ( &_krb_swap_tmp) +6, 2);  &swab(($x) +10, ( &_krb_swap_tmp) +4, 2);  &swab(($x) +12, ( &_krb_swap_tmp) +2, 2);  &swab(($x) +14, ( &_krb_swap_tmp) +0, 2);  &memcpy($x,  &_krb_swap_tmp, 16); }";
    }';
    eval 'sub swap_u_12 {
        local($x) = @_;
        eval "{ \'unsigned long\'  &_krb_swap_tmp[4];  &swab(($x) +0, ( &_krb_swap_tmp) +10, 2);  &swab(($x) +2, ( &_krb_swap_tmp) +8, 2);  &swab(($x) +4, ( &_krb_swap_tmp) +6, 2);  &swab(($x) +6, ( &_krb_swap_tmp) +4, 2);  &swab(($x) +8, ( &_krb_swap_tmp) +2, 2);  &swab(($x) +10, ( &_krb_swap_tmp) +0, 2);  &memcpy($x,  &_krb_swap_tmp, 12); }";
    }';
    eval 'sub swap_C_Block {
        local($x) = @_;
        eval "{ \'unsigned long\'  &_krb_swap_tmp[4];  &swab(($x) +0, ( &_krb_swap_tmp) +6, 2);  &swab(($x) +2, ( &_krb_swap_tmp) +4, 2);  &swab(($x) +4, ( &_krb_swap_tmp) +2, 2);  &swab(($x) +6, ( &_krb_swap_tmp) +0, 2);  &memcpy($x,  &_krb_swap_tmp, 8); }";
    }';
    eval 'sub swap_u_quad {
        local($x) = @_;
        eval "{ \'unsigned long\'  &_krb_swap_tmp[4];  &swab((&$x) +0, ( &_krb_swap_tmp) +6, 2);  &swab((&$x) +2, ( &_krb_swap_tmp) +4, 2);  &swab((&$x) +4, ( &_krb_swap_tmp) +2, 2);  &swab((&$x) +6, ( &_krb_swap_tmp) +0, 2);  &memcpy(&$x,  &_krb_swap_tmp, 8); }";
    }';
    eval 'sub swap_u_long {
        local($x) = @_;
        eval "{ \'unsigned long\'  &_krb_swap_tmp[4];  &swab((&$x) +0, ( &_krb_swap_tmp) +2, 2);  &swab((&$x) +2, ( &_krb_swap_tmp) +0, 2); $x =  &_krb_swap_tmp[0]; }";
    }';
    eval 'sub swap_u_short {
        local($x) = @_;
        eval "{ \'unsigned short\'  &_krb_swap_sh_tmp;  &swab((&$x), (& &_krb_swap_sh_tmp), 2); $x =   &_krb_swap_sh_tmp; }";
    }';
    eval 'sub K_FLAG_ORDER {0;}';
    eval 'sub K_FLAG_1 {1;}';
    eval 'sub K_FLAG_2 {1;}';
    eval 'sub K_FLAG_3 {1;}';
    eval 'sub K_FLAG_4 {1;}';
    eval 'sub K_FLAG_5 {1;}';
    eval 'sub K_FLAG_6 {1;}';
    eval 'sub K_FLAG_7 {1;}';
    if (!defined &PC) {
    }
    if (defined &OLDNAMES) {
	eval 'sub krb_mk_req { &mk_ap_req;}';
	eval 'sub krb_rd_req { &rd_ap_req;}';
	eval 'sub krb_kntoln { &an_to_ln;}';
	eval 'sub krb_set_key { &set_serv_key;}';
	eval 'sub krb_get_cred { &get_credentials;}';
	eval 'sub krb_mk_priv { &mk_private_msg;}';
	eval 'sub krb_rd_priv { &rd_private_msg;}';
	eval 'sub krb_mk_safe { &mk_safe_msg;}';
	eval 'sub krb_rd_safe { &rd_safe_msg;}';
	eval 'sub krb_mk_err { &mk_appl_err_msg;}';
	eval 'sub krb_rd_err { &rd_appl_err_msg;}';
	eval 'sub krb_ck_repl { &check_replay;}';
	eval 'sub krb_get_pw_in_tkt { &get_in_tkt;}';
	eval 'sub krb_get_svc_in_tkt { &get_svc_in_tkt;}';
	eval 'sub krb_get_pw_tkt { &get_pw_tkt;}';
	eval 'sub krb_realmofhost { &krb_getrealm;}';
	eval 'sub krb_get_phost { &get_phost;}';
	eval 'sub krb_get_krbhst { &get_krbhst;}';
	eval 'sub krb_get_lrealm { &get_krbrlm;}';
    }
    eval 'sub KOPT_DONT_MK_REQ {0x00000001;}';
    eval 'sub KOPT_DO_MUTUAL {0x00000002;}';
    eval 'sub KOPT_DONT_CANON {0x00000004;}';
    eval 'sub KRB_SENDAUTH_VLEN {8;}';
    if (defined &ATHENA_COMPAT) {
	eval 'sub KOPT_DO_OLDSTYLE {0x00000008;}';
    }
    if (defined &__cplusplus) {
    }
}
1;
