if (!defined &_SYS_FS_PC_LABEL_H) {
    eval 'sub _SYS_FS_PC_LABEL_H {1;}';
    if (defined &__cplusplus) {
    }
    require 'sys/isa_defs.ph';
    eval 'sub PCB_BPSEC {11;}';
    eval 'sub PCB_SPC {13;}';
    eval 'sub PCB_RESSEC {14;}';
    eval 'sub PCB_NFAT {16;}';
    eval 'sub PCB_NROOTENT {17;}';
    eval 'sub PCB_NSEC {19;}';
    eval 'sub PCB_MEDIA {21;}';
    eval 'sub PCB_SPF {22;}';
    eval 'sub PCB_SPT {24;}';
    eval 'sub PCB_NHEAD {26;}';
    eval 'sub PCB_HIDSEC {28;}';
    eval 'sub PCFS_PART {0x1be;}';
    eval 'sub PCFS_NUMPART {4;}';
    eval 'sub PCFS_BPB {0xb;}';
    eval 'sub PCFS_SIGN {0x1fe;}';
    eval 'sub DOS_SYSFAT12 {1;}';
    eval 'sub DOS_SYSFAT16 {4;}';
    eval 'sub DOS_SYSHUGE {6;}';
    eval 'sub DOS_F12MAXS {20740;}';
    eval 'sub DOS_F12MAXC {4086;}';
    eval 'sub DOS_ID1 {0xe9;}';
    eval 'sub DOS_ID2a {0xeb;}';
    eval 'sub DOS_ID2b {0x90;}';
    eval 'sub DOS_SIGN {0xaa55;}';
    eval 'sub PC_FATBLOCK {1;}';
    eval 'sub MD_FIXED {0xF8;}';
    eval 'sub SS8SPT {0xFE;}';
    eval 'sub DS8SPT {0xFF;}';
    eval 'sub SS9SPT {0xFC;}';
    eval 'sub DS9SPT {0xFD;}';
    eval 'sub DS18SPT {0xF0;}';
    eval 'sub DS9_15SPT {0xF9;}';
    eval 'sub PC_SECSIZE {512;}';
    if (defined( &i386)) {
	eval 'sub ltohs {
	    local($S) = @_;
	    eval "(*((&($S))))";
	}';
	eval 'sub ltohl {
	    local($L) = @_;
	    eval "(*((&($L))))";
	}';
	eval 'sub htols {
	    local($S) = @_;
	    eval "(*((&($S))))";
	}';
	eval 'sub htoll {
	    local($L) = @_;
	    eval "(*((&($L))))";
	}';
    }
    else {
	eval 'sub getbyte {
	    local($A, $N) = @_;
	    eval "(((&($A)))[$N])";
	}';
	eval 'sub ltohs {
	    local($S) = @_;
	    eval "(( &getbyte($S, 1) << 8) |  &getbyte($S, 0))";
	}';
	eval 'sub ltohl {
	    local($L) = @_;
	    eval "(( &getbyte($L, 3) << 24) | ( &getbyte($L, 2) << 16) | ( &getbyte($L, 1) << 8) |  &getbyte($L, 0))";
	}';
	eval 'sub htols {
	    local($S) = @_;
	    eval "(( &getbyte($S, 1) << 8) |  &getbyte($S, 0))";
	}';
	eval 'sub htoll {
	    local($L) = @_;
	    eval "(( &getbyte($L, 3) << 24) | ( &getbyte($L, 2) << 16) | ( &getbyte($L, 1) << 8) |  &getbyte($L, 0))";
	}';
    }
    if (defined &__cplusplus) {
    }
}
1;
