if (!defined &_SYS_FS_SNODE_H) {
    eval 'sub _SYS_FS_SNODE_H {1;}';
    require 'sys/types.ph';
    require 'sys/t_lock.ph';
    require 'sys/cred.ph';
    require 'sys/vnode.ph';
    require 'sys/dditypes.ph';
    if (defined &__cplusplus) {
    }
    eval 'sub SUPD {0x01;}';
    eval 'sub SACC {0x02;}';
    eval 'sub SCHG {0x04;}';
    eval 'sub SPRIV {0x08;}';
    eval 'sub SLOFFSET {0x10;}';
    eval 'sub SLOCKED {0x20;}';
    eval 'sub SWANT {0x40;}';
    if (defined &_KERNEL) {
	eval 'sub VTOS {
	    local($vp) = @_;
	    eval "((($vp)-> &v_data))";
	}';
	eval 'sub STOV {
	    local($sp) = @_;
	    eval "(&($sp)-> &s_vnode)";
	}';
	eval 'sub UNKNOWN_SIZE {0x7fffffff;}';
	eval 'sub STABLESIZE {256;}';
	eval 'sub STABLEHASH {
	    local($dev) = @_;
	    eval "(( &getmajor($dev) +  &getminor($dev)) & ( &STABLESIZE - 1))";
	}';
    }
    if (defined &__cplusplus) {
    }
}
1;
